import React from "react";
import { AccordionItemAction, AccordionItemActions, AccordionItemElement } from "./AccordionItemActions";
declare const Divider: import("@emotion/styled").StyledComponent<{
    theme?: import("@emotion/react").Theme | undefined;
    as?: React.ElementType<any, keyof React.JSX.IntrinsicElements> | undefined;
}, React.DetailedHTMLProps<React.HTMLAttributes<HTMLSpanElement>, HTMLSpanElement>, {}>;
export interface AccordionItemProps {
    /**
     * Can user toggle the accordion item by clicking it? Defaults to `true`.
     */
    interactive?: boolean;
    /**
     * Actions to show on the right side of the accordion item
     */
    actions?: React.ReactElement | null;
    /**
     * Left side icon
     */
    icon?: React.ReactElement | null;
    /**
     * Accordion title
     */
    title?: React.ReactNode;
    /**
     * Optional description
     */
    description?: string;
    /**
     * Append a class name
     */
    className?: string;
    /**
     * Render item opened by default
     */
    open?: boolean;
    /**
     * For testing purpose
     */
    "data-testid"?: string;
    /**
     * Append a class name to Icon
     */
    iconClassName?: string;
    children: React.ReactNode;
}
type AccordionItem = React.ComponentType<AccordionItemProps> & {
    Divider: typeof Divider;
    Actions: typeof AccordionItemActions;
    Action: typeof AccordionItemAction;
    Element: typeof AccordionItemElement;
};
export declare const AccordionItem: AccordionItem;
export {};
