"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault").default;
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.AccordionItemElement = exports.AccordionItemActions = exports.AccordionItemAction = void 0;
var _react = _interopRequireDefault(require("react"));
var _Button = require("../Button");
var _Tooltip = require("../Tooltip");
var AccordionItemActions = exports.AccordionItemActions = function AccordionItemActions(_ref) {
  var children = _ref.children;
  return /*#__PURE__*/_react.default.createElement(_react.default.Fragment, null, children);
};
var AccordionItemAction = exports.AccordionItemAction = function AccordionItemAction(_ref2) {
  var icon = _ref2.icon,
    _onClick = _ref2.onClick,
    tooltip = _ref2.tooltip,
    disabled = _ref2.disabled;
  var iconButton = /*#__PURE__*/_react.default.createElement(_Button.IconButton, {
    disabled: disabled,
    icon: icon,
    onClick: function onClick(e) {
      e.stopPropagation();
      _onClick();
    }
  });
  if (!tooltip) {
    return iconButton;
  }
  return /*#__PURE__*/_react.default.createElement(_Tooltip.Tooltip, {
    placement: "bottom",
    content: tooltip
  }, iconButton);
};
var AccordionItemElement = exports.AccordionItemElement = function AccordionItemElement(_ref3) {
  var element = _ref3.element;
  return /*#__PURE__*/_react.default.createElement("div", {
    onClick: function onClick(e) {
      return e.stopPropagation();
    }
  }, element);
};

//# sourceMappingURL=AccordionItemActions.js.map