"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault").default;
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.Alert = void 0;
var _objectWithoutProperties2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutProperties"));
var _react = _interopRequireDefault(require("react"));
var _emotion = require("emotion");
var _excluded = ["title", "type", "children"];
var alertStyles = (0, _emotion.css)({
  borderLeft: "3px solid red",
  margin: "5px 0 15px 0",
  padding: "2px 0 2px 10px",
  ".webiny-ui-alert__title": {
    fontWeight: 600,
    lineHeight: "150%",
    color: "var(--mdc-theme-on-surface)",
    marginBottom: 5
  },
  ".webiny-ui-alert__message": {
    lineHeight: "120%",
    fontSize: 14,
    color: "var(--mdc-theme-on-surface)"
  },
  "&.webiny-ui-alert--success": {
    borderColor: "#21CEAF"
  },
  "&.webiny-ui-alert--info": {
    borderColor: "#29A9DB"
  },
  "&.webiny-ui-alert--warning": {
    borderColor: "#F45C3C"
  },
  "&.webiny-ui-alert--danger": {
    borderColor: "#E4495C"
  }
});
/**
 * Use Alert component to display user's avatar.
 */
var Alert = exports.Alert = function Alert(props) {
  var title = props.title,
    type = props.type,
    children = props.children,
    rest = (0, _objectWithoutProperties2.default)(props, _excluded);
  return /*#__PURE__*/_react.default.createElement("div", Object.assign({}, rest, {
    className: alertStyles + " webiny-ui-alert webiny-ui-alert--" + type
  }), /*#__PURE__*/_react.default.createElement("p", {
    className: "webiny-ui-alert__title"
  }, title), /*#__PURE__*/_react.default.createElement("p", {
    className: "webiny-ui-alert__message"
  }, children));
};

//# sourceMappingURL=Alert.js.map