import React from "react";
import { AutoCompleteBaseProps } from "./types";
export declare enum Placement {
    top = "top",
    bottom = "bottom"
}
export interface AutoCompleteProps extends Omit<AutoCompleteBaseProps, "onChange"> {
    placement?: Placement;
    onChange?: (value: any, selection?: any) => void;
    loading?: boolean;
    noResultFound?: React.ReactNode;
    size?: "small" | "medium" | "large";
}
interface State {
    inputValue: string;
}
declare class AutoComplete extends React.Component<AutoCompleteProps, State> {
    static defaultProps: Partial<AutoCompleteProps>;
    state: State;
    /**
     * Helps us trigger some of the downshift's methods (eg. clearSelection) and helps us to avoid adding state.
     */
    downshift: any;
    componentDidUpdate(previousProps: AutoCompleteProps): void;
    /**
     * Renders options - based on user's input. It will try to match input text with available options.
     */
    private renderOptions;
    render(): React.JSX.Element;
}
export { AutoComplete };
