"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault").default;
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.Placement = exports.AutoComplete = void 0;
var _objectSpread2 = _interopRequireDefault(require("@babel/runtime/helpers/objectSpread2"));
var _objectWithoutProperties2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutProperties"));
var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));
var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));
var _callSuper2 = _interopRequireDefault(require("@babel/runtime/helpers/callSuper"));
var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));
var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));
var _react = _interopRequireDefault(require("react"));
var _downshift = _interopRequireDefault(require("downshift"));
var _Input = require("../Input");
var _classnames = _interopRequireDefault(require("classnames"));
var _Elevation = require("../Elevation");
var _Typography = require("../Typography");
var _keycode = _interopRequireDefault(require("keycode"));
var _styles = require("./styles");
var _utils = require("./utils");
var _isEqual = _interopRequireDefault(require("lodash/isEqual"));
var _reactSpinnerMaterial = _interopRequireDefault(require("react-spinner-material"));
var _emotion = require("emotion");
var _excluded = ["className", "options", "onChange", "value", "onInput", "validation", "placement"],
  _excluded2 = ["getInputProps", "openMenu"];
var _AutoComplete;
var menuStyles = (0, _emotion.css)({
  top: "unset !important",
  bottom: 75
});
var listStyles = (0, _emotion.css)({
  "&.autocomplete__options-list": {
    listStyle: "none",
    paddingLeft: 0,
    "& li": {
      margin: 0
    }
  }
});
var Placement = exports.Placement = /*#__PURE__*/function (Placement) {
  Placement["top"] = "top";
  Placement["bottom"] = "bottom";
  return Placement;
}({});
var Spinner = function Spinner() {
  return /*#__PURE__*/_react.default.createElement(_reactSpinnerMaterial.default, {
    size: 24,
    spinnerColor: "var(--mdc-theme-primary)",
    spinnerWidth: 2,
    visible: true
  });
};
var OptionsList = function OptionsList(_ref) {
  var placement = _ref.placement,
    getMenuProps = _ref.getMenuProps,
    children = _ref.children;
  return /*#__PURE__*/_react.default.createElement(_Elevation.Elevation, {
    z: 1,
    className: (0, _classnames.default)((0, _defineProperty2.default)({}, menuStyles, placement === Placement.top))
  }, /*#__PURE__*/_react.default.createElement("ul", Object.assign({
    className: (0, _classnames.default)("autocomplete__options-list", listStyles)
  }, getMenuProps()), children));
};
var AutoComplete = exports.AutoComplete = /*#__PURE__*/function (_React$Component) {
  function AutoComplete() {
    var _this;
    (0, _classCallCheck2.default)(this, AutoComplete);
    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }
    _this = (0, _callSuper2.default)(this, AutoComplete, [].concat(args));
    (0, _defineProperty2.default)(_this, "state", {
      inputValue: ""
    });
    /**
     * Helps us trigger some of the downshift's methods (eg. clearSelection) and helps us to avoid adding state.
     */
    (0, _defineProperty2.default)(_this, "downshift", /*#__PURE__*/_react.default.createRef());
    return _this;
  }
  (0, _inherits2.default)(AutoComplete, _React$Component);
  return (0, _createClass2.default)(AutoComplete, [{
    key: "componentDidUpdate",
    value: function componentDidUpdate(previousProps) {
      var _this2 = this;
      var _this$props = this.props,
        value = _this$props.value,
        options = _this$props.options;
      var previousValue = previousProps.value;
      if (!(0, _isEqual.default)(value, previousValue)) {
        var item = null;
        if (value) {
          if (typeof value === "object") {
            item = value;
          } else {
            item = options.find(function (option) {
              return value === (0, _utils.getOptionValue)(option, _this2.props);
            }) || null;
          }
        }
        var downshift = this.downshift.current;
        downshift && downshift.selectItem(item);
      }
    }

    /**
     * Renders options - based on user's input. It will try to match input text with available options.
     */
  }, {
    key: "renderOptions",
    value: function renderOptions(_ref2) {
      var _this3 = this;
      var options = _ref2.options,
        isOpen = _ref2.isOpen,
        highlightedIndex = _ref2.highlightedIndex,
        selectedItem = _ref2.selectedItem,
        getMenuProps = _ref2.getMenuProps,
        getItemProps = _ref2.getItemProps,
        placement = _ref2.placement;
      if (!isOpen) {
        return null;
      }
      /**
       * Suggest user to start typing when there are no options available to choose from.
       */
      if (!this.state.inputValue && !options.length) {
        return /*#__PURE__*/_react.default.createElement(OptionsList, {
          placement: placement,
          getMenuProps: getMenuProps
        }, /*#__PURE__*/_react.default.createElement("li", null, /*#__PURE__*/_react.default.createElement(_Typography.Typography, {
          use: "body2"
        }, "Start typing to find entry")));
      }
      var renderItem = this.props.renderItem;
      var filtered = options.filter(function (item) {
        // 2) At the end, we want to show only options that are matched by typed text.
        if (!_this3.state.inputValue) {
          return true;
        }
        if (item.aliases) {
          return (0, _utils.findInAliases)(item, _this3.state.inputValue);
        }
        return (0, _utils.getOptionText)(item, _this3.props).toLowerCase().includes(_this3.state.inputValue.toLowerCase());
      });
      if (!filtered.length) {
        return /*#__PURE__*/_react.default.createElement(OptionsList, {
          placement: placement,
          getMenuProps: getMenuProps
        }, /*#__PURE__*/_react.default.createElement("li", null, /*#__PURE__*/_react.default.createElement(_Typography.Typography, {
          use: "body2"
        }, "No results."), this.props.noResultFound));
      }
      return /*#__PURE__*/_react.default.createElement(OptionsList, {
        placement: placement,
        getMenuProps: getMenuProps
      }, filtered.map(function (item, index) {
        var itemValue = (0, _utils.getOptionValue)(item, _this3.props);

        // Base classes.
        var itemClassNames = (0, _defineProperty2.default)((0, _defineProperty2.default)((0, _defineProperty2.default)({}, _styles.suggestionList, true), "highlighted", highlightedIndex === index), "selected", false);

        // Add "selected" class if the item is selected.
        if (selectedItem && (0, _utils.getOptionValue)(selectedItem, _this3.props) === itemValue) {
          itemClassNames.selected = true;
        }

        // Render the item.
        return /*#__PURE__*/_react.default.createElement("li", Object.assign({
          key: itemValue
        }, getItemProps({
          index: index,
          item: item,
          className: (0, _classnames.default)(itemClassNames)
        })), renderItem.call(_this3, item, index));
      }));
    }
  }, {
    key: "render",
    value: function render() {
      var _this4 = this;
      var _this$props2 = this.props,
        className = _this$props2.className,
        options = _this$props2.options,
        _onChange = _this$props2.onChange,
        value = _this$props2.value,
        onInput = _this$props2.onInput,
        _this$props2$validati = _this$props2.validation,
        validation = _this$props2$validati === void 0 ? {
          isValid: null,
          message: null
        } : _this$props2$validati,
        placement = _this$props2.placement,
        otherInputProps = (0, _objectWithoutProperties2.default)(_this$props2, _excluded);

      // Downshift related props.
      var downshiftProps = {
        className: _styles.autoCompleteStyle,
        itemToString: function itemToString(item) {
          return (0, _utils.getOptionText)(item, _this4.props);
        },
        defaultSelectedItem: value,
        onChange: function onChange(selection) {
          if (!selection || !_onChange) {
            return;
          }
          _onChange((0, _utils.getOptionValue)(selection, _this4.props), selection);
          _this4.setState(function (state) {
            return (0, _objectSpread2.default)((0, _objectSpread2.default)({}, state), {}, {
              inputValue: ""
            });
          });
        }
      };
      return /*#__PURE__*/_react.default.createElement("div", {
        className: (0, _classnames.default)(_styles.autoCompleteStyle, this.props.size ? "webiny-ui-autocomplete--size-".concat(this.props.size) : null, className)
      }, /*#__PURE__*/_react.default.createElement(_downshift.default, Object.assign({}, downshiftProps, {
        ref: this.downshift
      }), function (_ref3) {
        var getInputProps = _ref3.getInputProps,
          openMenu = _ref3.openMenu,
          rest = (0, _objectWithoutProperties2.default)(_ref3, _excluded2);
        return /*#__PURE__*/_react.default.createElement("div", null, /*#__PURE__*/_react.default.createElement(_Input.Input, getInputProps((0, _objectSpread2.default)((0, _objectSpread2.default)({
          // This prop is above `otherInputProps` since it can be overridden by the user.
          trailingIcon: _this4.props.loading && /*#__PURE__*/_react.default.createElement(Spinner, null)
        }, otherInputProps), {}, {
          // @ts-expect-error
          size: _this4.props.size,
          validation: validation,
          rawOnChange: true,
          onChange: function onChange(ev) {
            return ev;
          },
          onBlur: function onBlur(ev) {
            return ev;
          },
          onFocus: function onFocus(ev) {
            openMenu();
            otherInputProps.onFocus && otherInputProps.onFocus(ev);
          },
          onKeyDown: function onKeyDown(ev) {
            var keyCode = (0, _keycode.default)(ev);
            if (keyCode === "backspace") {
              setTimeout(function () {
                if (_onChange) {
                  _onChange(null);
                  openMenu();
                }
              }, 50);
            }
          },
          onKeyUp: function onKeyUp(ev) {
            var keyCode = (0, _keycode.default)(ev);
            var target = ev.currentTarget;
            var inputValue = target.value || "";

            // If user pressed 'esc', 'enter' or similar...
            if (keyCode && keyCode.length > 1 && keyCode !== "backspace") {
              return;
            }

            // If values are the same, exit, do not update current search term.
            if (inputValue === _this4.state.inputValue) {
              return;
            }
            _this4.setState(function (state) {
              return (0, _objectSpread2.default)((0, _objectSpread2.default)({}, state), {}, {
                inputValue: inputValue
              });
            }, function () {
              onInput && onInput(inputValue);
            });
          }
        }))), !otherInputProps.disabled && !otherInputProps.readOnly && _this4.renderOptions((0, _objectSpread2.default)((0, _objectSpread2.default)({}, rest), {}, {
          options: options,
          placement: placement
        })));
      }));
    }
  }]);
}(_react.default.Component);
_AutoComplete = AutoComplete;
(0, _defineProperty2.default)(AutoComplete, "defaultProps", {
  valueProp: "id",
  textProp: "name",
  options: [],
  placement: Placement.bottom,
  /**
   * We cast this as AutoComplete because renderItem() is executed via .call() where AutoComplete instance is assigned as this.
   */
  renderItem: function renderItem(item) {
    return /*#__PURE__*/_react.default.createElement(_Typography.Typography, {
      use: "body2"
    }, (0, _utils.getOptionText)(item, this.props));
  }
});

//# sourceMappingURL=AutoComplete.js.map