import React from "react";
export interface AvatarProps {
    /**
     * CSS class name.
     */
    className?: string;
    /**
     * Style object.
     */
    style?: React.CSSProperties;
    /**
     * Avatar image source.
     */
    src?: string | null;
    /**
     * "alt" text.
     */
    alt?: string;
    /**
     * Width.
     */
    width?: number;
    /**
     * Height.
     */
    height?: number;
    /**
     * Pass a custom image component to be rendered instead of a simple <img> element.
     * @param props
     */
    renderImage?: (props: {
        src: string;
        alt?: string;
    }) => React.ReactElement;
    /**
     * Text that will be shown when there is no image (usually user's initials).
     */
    fallbackText: string;
}
/**
 * Use Avatar component to display user's avatar.
 */
export declare const Avatar: (props: AvatarProps) => React.JSX.Element;
