"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault").default;
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.Avatar = void 0;
var _objectSpread2 = _interopRequireDefault(require("@babel/runtime/helpers/objectSpread2"));
var _objectWithoutProperties2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutProperties"));
var _react = _interopRequireDefault(require("react"));
var _emotion = require("emotion");
var _classnames = _interopRequireDefault(require("classnames"));
var _excluded = ["className", "width", "height", "src", "alt", "fallbackText", "renderImage"];
var avatar = (0, _emotion.css)({
  borderRadius: "50%",
  display: "block",
  //alignItems: "center",
  //justifyContent: "center",
  width: 38,
  height: 38,
  position: "relative",
  top: -7,
  right: 7,
  overflow: "hidden",
  background: "var(--mdc-theme-background)",
  color: "var(--mdc-theme-text-secondary-on-background)",
  div: {
    textAlign: "center",
    display: "flex",
    alignContent: "center",
    justifyContent: "center",
    flexDirection: "column",
    width: 38,
    height: 38,
    fontSize: "1rem",
    span: {
      paddingBottom: 2
    }
  },
  img: {
    width: "100% !important",
    height: "100% !important",
    objectFit: "cover"
  }
});
/**
 * Use Avatar component to display user's avatar.
 */
var Avatar = exports.Avatar = function Avatar(props) {
  var className = props.className,
    _props$width = props.width,
    width = _props$width === void 0 ? 38 : _props$width,
    _props$height = props.height,
    height = _props$height === void 0 ? 38 : _props$height,
    src = props.src,
    alt = props.alt,
    fallbackText = props.fallbackText,
    renderImage = props.renderImage,
    rest = (0, _objectWithoutProperties2.default)(props, _excluded);
  var renderedImage;
  var imageProps = {
    src: src,
    alt: alt
  };
  if (src) {
    if (typeof renderImage === "function") {
      renderedImage = renderImage((0, _objectSpread2.default)((0, _objectSpread2.default)({}, imageProps), {}, {
        src: src
      }));
    } else {
      renderedImage = /*#__PURE__*/_react.default.createElement("img", Object.assign({}, imageProps, {
        alt: alt,
        src: src
      }));
    }
  }
  return /*#__PURE__*/_react.default.createElement("div", Object.assign({}, rest, {
    className: (0, _classnames.default)(avatar, className),
    style: (0, _objectSpread2.default)((0, _objectSpread2.default)({}, props.style), {}, {
      width: width,
      height: height
    })
  }), props.src ? renderedImage : /*#__PURE__*/_react.default.createElement("div", null, /*#__PURE__*/_react.default.createElement("span", null, fallbackText.split(" ").map(function (word) {
    return word.charAt(0);
  }).join("").toUpperCase())));
};

//# sourceMappingURL=Avatar.js.map