"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault").default;
var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard").default;
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.CopyButton = void 0;
var _objectWithoutProperties2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutProperties"));
var _react = _interopRequireWildcard(require("react"));
var _file_copy24px = require("../assets/file_copy-24px.svg");
var _index = require("../index");
var _excluded = ["value", "onCopy"];
/**
 * Shows the icon button.
 */
var CopyButton = exports.CopyButton = function CopyButton(props) {
  var value = props.value,
    onCopy = props.onCopy,
    otherProps = (0, _objectWithoutProperties2.default)(props, _excluded);
  var copyToClipboard = (0, _react.useCallback)(function () {
    navigator.clipboard.writeText(value);
    if (typeof onCopy === "function") {
      onCopy();
    }
  }, [value]);
  return /*#__PURE__*/_react.default.createElement(_index.IconButton, Object.assign({}, otherProps, {
    onClick: copyToClipboard,
    icon: /*#__PURE__*/_react.default.createElement(_file_copy24px.ReactComponent, null)
  }));
};

//# sourceMappingURL=CopyButton.js.map