import React from "react";
import { IconButtonProps as RmwcIconButtonProps } from "@rmwc/icon-button";
import { FormComponentProps } from "../../types";
export interface IconButtonProps extends Omit<FormComponentProps, "onChange">, RmwcIconButtonProps {
    id?: string;
    /**
     * Icon should be provided as an SvgComponent.
     */
    icon: React.ReactNode;
    /**
     * Button label
     */
    label?: string;
    /**
     * onClick handler
     * @param event
     */
    onClick?: (event: React.MouseEvent) => void;
    /**
     * Custom CSS class
     */
    className?: string;
    /**
     * For testing purposes.
     */
    "data-testid"?: string;
    /**
     * Should icon be disabled?
     */
    disabled?: boolean;
    children?: React.ReactNode;
}
/**
 * Shows the icon button.
 */
declare const IconButton: (props: IconButtonProps) => React.JSX.Element;
export { IconButton };
