import React from "react";
import { FormComponentProps } from "../types";
interface Props extends FormComponentProps {
    id?: string;
    label?: string;
    disabled?: boolean;
    onClick?: (value: boolean) => void;
    indeterminate?: boolean;
    description?: string;
    "data-testid"?: string;
    children?: React.ReactNode;
}
/**
 * Single Checkbox component can be used to store simple boolean values.
 *
 * Grouping multiple Checkbox components with CheckboxGroup will allow to store an array of selected values.
 * In that case, each Checkbox component must receive value and onChange callback via props.
 */
declare class Checkbox extends React.Component<Props> {
    onChange: (e: React.SyntheticEvent<HTMLInputElement>) => void;
    render(): React.JSX.Element;
}
export default Checkbox;
