"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault").default;
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;
var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));
var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));
var _callSuper2 = _interopRequireDefault(require("@babel/runtime/helpers/callSuper"));
var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));
var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));
var _react = _interopRequireDefault(require("react"));
var _checkbox = require("@rmwc/checkbox");
var _FormElementMessage = require("../FormElementMessage");
/**
 * Single Checkbox component can be used to store simple boolean values.
 *
 * Grouping multiple Checkbox components with CheckboxGroup will allow to store an array of selected values.
 * In that case, each Checkbox component must receive value and onChange callback via props.
 */
var Checkbox = /*#__PURE__*/function (_React$Component) {
  function Checkbox() {
    var _this;
    (0, _classCallCheck2.default)(this, Checkbox);
    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }
    _this = (0, _callSuper2.default)(this, Checkbox, [].concat(args));
    (0, _defineProperty2.default)(_this, "onChange", function (e) {
      _this.props.onChange && _this.props.onChange(e.target.checked);
    });
    return _this;
  }
  (0, _inherits2.default)(Checkbox, _React$Component);
  return (0, _createClass2.default)(Checkbox, [{
    key: "render",
    value: function render() {
      var _this$props = this.props,
        id = _this$props.id,
        value = _this$props.value,
        label = _this$props.label,
        disabled = _this$props.disabled,
        indeterminate = _this$props.indeterminate,
        description = _this$props.description,
        validation = _this$props.validation,
        _onClick = _this$props.onClick;
      var _ref = validation || {},
        validationIsValid = _ref.isValid,
        validationMessage = _ref.message;
      return /*#__PURE__*/_react.default.createElement(_react.default.Fragment, null, /*#__PURE__*/_react.default.createElement(_checkbox.Checkbox, {
        id: id,
        indeterminate: indeterminate,
        disabled: disabled,
        checked: Boolean(value),
        onChange: this.onChange,
        onClick: function onClick() {
          return typeof _onClick === "function" && _onClick(Boolean(value));
        },
        label: label,
        "data-testid": this.props["data-testid"]
      }), validationIsValid === false && /*#__PURE__*/_react.default.createElement(_FormElementMessage.FormElementMessage, {
        error: true
      }, validationMessage), validationIsValid !== false && description && /*#__PURE__*/_react.default.createElement(_FormElementMessage.FormElementMessage, null, description));
    }
  }]);
}(_react.default.Component);
var _default = exports.default = Checkbox;

//# sourceMappingURL=Checkbox.js.map