"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault").default;
var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard").default;
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.Chip = void 0;
var _objectWithoutProperties2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutProperties"));
var _react = _interopRequireWildcard(require("react"));
var _chip = require("@rmwc/chip");
var _excluded = ["children", "trailingIcon", "onRemove"];
var Chip = exports.Chip = function Chip(props) {
  var children = props.children,
    trailingIcon = props.trailingIcon,
    onRemove = props.onRemove,
    rest = (0, _objectWithoutProperties2.default)(props, _excluded);
  var onRemoveCb = (0, _react.useCallback)(function (ev) {
    if (!onRemove) {
      return;
    }
    onRemove(ev);
  }, [onRemove]);
  var trailingIconElement = null;
  if (trailingIcon) {
    trailingIconElement = /*#__PURE__*/_react.default.createElement("span", {
      className: "mdc-chip__icon mdc-chip__icon--trailing",
      onClick: onRemoveCb
    }, trailingIcon);
  }
  return /*#__PURE__*/_react.default.createElement(_chip.Chip, rest, children, " ", trailingIconElement);
};

//# sourceMappingURL=Chip.js.map