"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault").default;
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.CodeEditor = void 0;
var _objectWithoutProperties2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutProperties"));
var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));
var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));
var _callSuper2 = _interopRequireDefault(require("@babel/runtime/helpers/callSuper"));
var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));
var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));
var _react = _interopRequireDefault(require("react"));
var _emotion = require("emotion");
var _reactAce = _interopRequireDefault(require("react-ace"));
require("brace/mode/html");
require("brace/mode/json");
require("brace/ext/searchbox");
require("brace/theme/github");
require("brace/theme/twilight");
require("brace/theme/chrome");
var _FormElementMessage = require("../FormElementMessage");
var _excluded = ["value", "description", "validation", "theme"]; // Modes
// Extensions
// Themes
/**
 * Controls the helper text below the checkbox.
 * @type {string}
 */
var webinyCheckboxHelperText = (0, _emotion.css)({}, {
  "&.mdc-text-field-helper-text": {
    paddingTop: 5
  }
});
/**
 * CodeEditor component can be used to store simple boolean values.
 */
var CodeEditor = exports.CodeEditor = /*#__PURE__*/function (_React$Component) {
  function CodeEditor() {
    var _this;
    (0, _classCallCheck2.default)(this, CodeEditor);
    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }
    _this = (0, _callSuper2.default)(this, CodeEditor, [].concat(args));
    (0, _defineProperty2.default)(_this, "onChange", function (value) {
      _this.props.onChange && _this.props.onChange(value);
    });
    return _this;
  }
  (0, _inherits2.default)(CodeEditor, _React$Component);
  return (0, _createClass2.default)(CodeEditor, [{
    key: "render",
    value: function render() {
      var _this$props = this.props,
        value = _this$props.value,
        description = _this$props.description,
        validation = _this$props.validation,
        _this$props$theme = _this$props.theme,
        theme = _this$props$theme === void 0 ? "github" : _this$props$theme,
        rest = (0, _objectWithoutProperties2.default)(_this$props, _excluded);
      var _ref = validation || {},
        validationIsValid = _ref.isValid,
        validationMessage = _ref.message;
      return /*#__PURE__*/_react.default.createElement(_react.default.Fragment, null, /*#__PURE__*/_react.default.createElement(_reactAce.default, Object.assign({
        value: value ? String(value) : "",
        theme: theme,
        onChange: this.onChange
      }, rest, {
        width: "100%",
        className: "mdc-text-field",
        editorProps: {
          $blockScrolling: Infinity // Suppresses scrolling warning in console.
        }
      })), validationIsValid === false && /*#__PURE__*/_react.default.createElement(_FormElementMessage.FormElementMessage, {
        error: true,
        className: webinyCheckboxHelperText
      }, validationMessage), validationIsValid !== false && description && /*#__PURE__*/_react.default.createElement(_FormElementMessage.FormElementMessage, {
        className: webinyCheckboxHelperText
      }, description));
    }
  }]);
}(_react.default.Component);

//# sourceMappingURL=CodeEditor.js.map