import React from "react";
import { ColorState } from "react-color";
import { FormComponentProps } from "../types";
interface ColorPickerState {
    showColorPicker: boolean;
}
interface ColorPickerProps extends FormComponentProps {
    label?: string;
    disable?: boolean;
    description?: string;
    align?: "left" | "right";
}
/**
 * Use ColorPicker component to display a list of choices, once the handler is triggered.
 */
declare class ColorPicker extends React.Component<ColorPickerProps, ColorPickerState> {
    colorPickerRef: React.RefObject<HTMLDivElement>;
    state: {
        showColorPicker: boolean;
    };
    componentDidMount(): void;
    componentWillUnmount(): void;
    handleClickOutside: (event: MouseEvent) => void;
    handleClick: (e: React.MouseEvent) => void;
    handleClose: (e: React.MouseEvent) => void;
    handleChange: (color: ColorState) => void;
    render(): React.JSX.Element;
}
export { ColorPicker };
