import React from "react";
interface ChildrenRenderProp {
    showConfirmation: (onAccept?: () => void, onCancel?: () => void) => any;
}
interface ConfirmationCallbacks {
    onAccept?: () => void;
    onCancel?: () => void;
}
interface Props {
    title?: React.ReactNode;
    message?: React.ReactNode;
    loading?: React.ReactNode;
    "data-testid"?: string;
    children: (props: ChildrenRenderProp) => React.ReactNode;
    disableConfirm?: boolean;
    style?: React.CSSProperties;
}
interface ConfirmationDialogState {
    show: boolean;
    loading: boolean;
}
/**
 * Use ConfirmationDialog component to display a list of choices, once the handler is triggered.
 */
declare class ConfirmationDialog extends React.Component<Props, ConfirmationDialogState> {
    static defaultProps: {
        title: string;
        message: string;
        loading: React.JSX.Element;
    };
    __isMounted: boolean;
    callbacks: ConfirmationCallbacks;
    state: {
        show: boolean;
        loading: boolean;
    };
    componentDidMount(): void;
    componentWillUnmount(): void;
    private readonly showConfirmation;
    private readonly hideConfirmation;
    private readonly onAccept;
    private readonly onCancel;
    render(): React.JSX.Element;
}
export { ConfirmationDialog };
