"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault").default;
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.ConfirmationDialog = void 0;
var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));
var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));
var _callSuper2 = _interopRequireDefault(require("@babel/runtime/helpers/callSuper"));
var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));
var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));
var _react = _interopRequireDefault(require("react"));
var _Dialog = require("./../Dialog");
var _Progress = require("../Progress");
var _Button = require("../Button");
/**
 * Use ConfirmationDialog component to display a list of choices, once the handler is triggered.
 */
var ConfirmationDialog = exports.ConfirmationDialog = /*#__PURE__*/function (_React$Component) {
  function ConfirmationDialog() {
    var _this;
    (0, _classCallCheck2.default)(this, ConfirmationDialog);
    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }
    _this = (0, _callSuper2.default)(this, ConfirmationDialog, [].concat(args));
    (0, _defineProperty2.default)(_this, "__isMounted", false);
    (0, _defineProperty2.default)(_this, "callbacks", {
      onAccept: function onAccept() {
        return void 0;
      },
      onCancel: function onCancel() {
        return void 0;
      }
    });
    (0, _defineProperty2.default)(_this, "state", {
      show: false,
      loading: false
    });
    (0, _defineProperty2.default)(_this, "showConfirmation", function (onAccept, onCancel) {
      _this.callbacks = {
        onAccept: onAccept,
        onCancel: onCancel
      };
      _this.setState({
        show: true
      });
    });
    (0, _defineProperty2.default)(_this, "hideConfirmation", function () {
      _this.setState({
        show: false
      });
    });
    (0, _defineProperty2.default)(_this, "onAccept", async function () {
      var onAccept = _this.callbacks.onAccept;
      if (typeof onAccept === "function") {
        _this.setState({
          loading: true
        });
        await onAccept();
        if (_this.__isMounted) {
          _this.setState({
            loading: false,
            show: false
          });
        }
      }
    });
    (0, _defineProperty2.default)(_this, "onCancel", async function () {
      var onCancel = _this.callbacks.onCancel;
      if (typeof onCancel === "function") {
        await onCancel();
      }
    });
    return _this;
  }
  (0, _inherits2.default)(ConfirmationDialog, _React$Component);
  return (0, _createClass2.default)(ConfirmationDialog, [{
    key: "componentDidMount",
    value: function componentDidMount() {
      this.__isMounted = true;
    }
  }, {
    key: "componentWillUnmount",
    value: function componentWillUnmount() {
      this.__isMounted = false;
    }
  }, {
    key: "render",
    value: function render() {
      return /*#__PURE__*/_react.default.createElement(_react.default.Fragment, null, /*#__PURE__*/_react.default.createElement(_Dialog.Dialog, {
        style: this.props.style,
        open: this.state.show,
        onClose: this.hideConfirmation,
        "data-testid": this.props["data-testid"]
      }, this.state.loading ? this.props.loading : null, /*#__PURE__*/_react.default.createElement(_Dialog.DialogTitle, null, this.props.title), /*#__PURE__*/_react.default.createElement(_Dialog.DialogContent, null, this.props.message), /*#__PURE__*/_react.default.createElement(_Dialog.DialogActions, null, /*#__PURE__*/_react.default.createElement(_Dialog.DialogCancel, {
        onClick: this.onCancel
      }, "Cancel"), /*#__PURE__*/_react.default.createElement(_Button.ButtonPrimary, {
        "data-testid": "confirmationdialog-confirm-action",
        onClick: this.onAccept,
        disabled: this.props.disableConfirm
      }, "Confirm"))), this.props.children({
        showConfirmation: this.showConfirmation
      }));
    }
  }]);
}(_react.default.Component);
(0, _defineProperty2.default)(ConfirmationDialog, "defaultProps", {
  title: "Confirmation",
  message: "Are you sure you want to continue?",
  loading: /*#__PURE__*/_react.default.createElement(_Progress.CircularProgress, null)
});

//# sourceMappingURL=ConfirmationDialog.js.map