"use strict";

var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard").default;
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.DateComponent = void 0;
var _react = _interopRequireWildcard(require("react"));
var DateComponent = exports.DateComponent = function DateComponent(_ref) {
  var date = _ref.date,
    _ref$options = _ref.options,
    options = _ref$options === void 0 ? {
      day: "numeric",
      month: "long",
      year: "numeric"
    } : _ref$options,
    locale = _ref.locale;
  var formatDate = (0, _react.useMemo)(function () {
    // Convert the input string to a Date object
    var dateObject = new Date(date);

    // Check if the input date is valid
    if (isNaN(dateObject.getDate())) {
      console.log("Invalid date");
      return "";
    }

    /**
     *  Determine the final locale:
     *  - use the prop `locale` if provided.
     *  - try to guess the navigator language, use it only if it's a subset of `en`locale, since the admin is not localized.
     *  - use `en-US`as default.
     */
    var localeCode = locale || (navigator.language && navigator.language.startsWith("en") ? navigator.language : "en-US");
    return new Intl.DateTimeFormat(localeCode, options).format(dateObject);
  }, [date, locale, options]);
  return /*#__PURE__*/_react.default.createElement(_react.default.Fragment, null, formatDate);
};

//# sourceMappingURL=Date.js.map