"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault").default;
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.DialogTitle = exports.DialogContent = exports.DialogCancel = exports.DialogButton = exports.DialogActions = exports.DialogAccept = exports.Dialog = void 0;
var _taggedTemplateLiteral2 = _interopRequireDefault(require("@babel/runtime/helpers/taggedTemplateLiteral"));
var _objectWithoutProperties2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutProperties"));
var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));
var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));
var _callSuper2 = _interopRequireDefault(require("@babel/runtime/helpers/callSuper"));
var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));
var _react = _interopRequireDefault(require("react"));
var _reactDom = _interopRequireDefault(require("react-dom"));
var _dialog = require("@rmwc/dialog");
var _emotion = require("emotion");
var _Helpers = require("../Helpers");
var _templateObject;
var _excluded = ["children"];
var Dialog = exports.Dialog = /*#__PURE__*/function (_React$Component) {
  function Dialog(props) {
    var _this;
    (0, _classCallCheck2.default)(this, Dialog);
    _this = (0, _callSuper2.default)(this, Dialog, [props]);
    /**
     * We can safely cast
     */
    _this.container = document.getElementById("dialog-container");
    if (!_this.container) {
      _this.container = document.createElement("div");
      _this.container.setAttribute("id", "dialog-container");
      var container = _this.container;
      document.body && document.body.appendChild(container);
    }
    return _this;
  }
  (0, _inherits2.default)(Dialog, _React$Component);
  return (0, _createClass2.default)(Dialog, [{
    key: "render",
    value: function render() {
      var _this$props = this.props,
        children = _this$props.children,
        props = (0, _objectWithoutProperties2.default)(_this$props, _excluded);
      var container = this.container;

      // Let's pass "permanent" / "persistent" / "temporary" flags as "mode" prop instead.
      return /*#__PURE__*/_reactDom.default.createPortal(/*#__PURE__*/_react.default.createElement(_dialog.Dialog, (0, _Helpers.getClasses)(props, "webiny-ui-dialog"), children), container);
    }
  }]);
}(_react.default.Component);
/**
 * Dialog's header, which can accept DialogHeaderTitle component or any other set of components.
 */
var DialogTitle = exports.DialogTitle = function DialogTitle(props) {
  return /*#__PURE__*/_react.default.createElement(_dialog.DialogTitle, Object.assign({}, (0, _Helpers.getClasses)(props, "webiny-ui-dialog__title"), {
    style: {
      marginBottom: "0"
    }
  }));
};
/**
 * A simple component for showing dialog's body.
 */
var DialogContent = exports.DialogContent = function DialogContent(props) {
  return /*#__PURE__*/_react.default.createElement(_dialog.DialogContent, (0, _Helpers.getClasses)(props, "webiny-ui-dialog__content"));
};
var addMargin = (0, _emotion.css)(_templateObject || (_templateObject = (0, _taggedTemplateLiteral2.default)(["\n    button:last-of-type {\n        margin-left: 8px;\n    }\n"])));

/**
 * Can be used to show accept and cancel buttons.
 */
var DialogActions = exports.DialogActions = function DialogActions(props) {
  return /*#__PURE__*/_react.default.createElement(_dialog.DialogActions, (0, _Helpers.getClasses)(props, [addMargin, "webiny-ui-dialog__actions"]));
};
/**
 * Use this to show a simple button.
 */
var DialogButton = exports.DialogButton = function DialogButton(props) {
  return /*#__PURE__*/_react.default.createElement(_dialog.DialogButton, (0, _Helpers.getClasses)(props, "webiny-ui-dialog__button"));
};
/**
 * Use this to close the dialog without taking any additional action.
 */
var DialogCancel = exports.DialogCancel = function DialogCancel(props) {
  return /*#__PURE__*/_react.default.createElement(DialogButton, Object.assign({}, (0, _Helpers.getClasses)(props, "webiny-ui-dialog__button webiny-ui-dialog__button--cancel"), {
    action: "close",
    "data-testid": "dialog-cancel"
  }), props.children);
};
/**
 * Use this to close the dialog without taking any additional action.
 */
var DialogAccept = exports.DialogAccept = function DialogAccept(props) {
  return /*#__PURE__*/_react.default.createElement(DialogButton, Object.assign({}, (0, _Helpers.getClasses)(props, "webiny-ui-dialog__button webiny-ui-dialog__button--accept"), {
    action: "accept",
    "data-testid": "dialog-accept"
  }), props.children);
};

//# sourceMappingURL=Dialog.js.map