import React from "react";
import { CSSObject } from "@emotion/react";
import { DrawerProps as RmwcDrawerProps, DrawerHeaderProps as RmwcDrawerHeaderProps, DrawerContentProps as RmwcDrawerContentProps } from "@rmwc/drawer";
type DrawerHeaderProps = RmwcDrawerHeaderProps & {
    /**
     * Drawer content.
     */
    children: React.ReactNode;
    /**
     * CSS class name
     */
    className?: string;
};
/**
 * Shows header of the drawer.
 */
declare const DrawerHeader: (props: DrawerHeaderProps) => React.JSX.Element;
export type DrawerContentProps = RmwcDrawerContentProps & {
    /**
     * Drawer content.
     */
    children: React.ReactNode;
    /**
     * CSS class name
     */
    className?: string;
};
/**
 * Shows drawer content. It can be anything, but commonly a List component would suffice here.
 */
declare const DrawerContent: (props: DrawerContentProps) => React.JSX.Element;
type DrawerProps = RmwcDrawerProps & {
    /**
     * Drawer content.
     */
    children: React.ReactNode;
    /**
     * CSS class name
     */
    className?: string;
    style?: CSSObject;
};
/**
 * Use Drawer component to display navigation for the whole app or just a small section of it.
 */
declare const Drawer: ({ style, children, ...props }: DrawerProps) => React.JSX.Element;
declare const DrawerRight: (props: DrawerProps) => React.JSX.Element;
declare const DrawerLeft: (props: DrawerProps) => React.JSX.Element;
export { Drawer, DrawerHeader, DrawerContent, DrawerRight, DrawerLeft };
