import React from "react";
interface ChildrenRenderPropRowCallableParams {
    index: number;
    data: any;
}
interface ChildrenRenderPropRowCallable {
    (params: ChildrenRenderPropRowCallableParams): React.ReactNode;
}
interface ChildrenRenderPropHeaderCallable {
    (): React.ReactNode;
}
interface ChildrenRenderPropEmptyCallable {
    (): React.ReactNode;
}
interface ChildrenRenderProp {
    actions: {
        add: (index?: number) => () => void;
        remove: (index: number) => () => void;
    };
    header: (cb: ChildrenRenderPropHeaderCallable) => React.ReactNode;
    row: (cb: ChildrenRenderPropRowCallable) => React.ReactNode;
    empty: (cb: ChildrenRenderPropEmptyCallable) => React.ReactNode;
}
interface FieldsetProps {
    value?: any[];
    description?: string;
    validation?: {
        isValid: null | boolean;
        message?: string;
    };
    onChange: (value: any) => void;
    children: (props: ChildrenRenderProp) => React.ReactNode;
}
declare class Fieldset extends React.Component<FieldsetProps> {
    static defaultProps: Partial<FieldsetProps>;
    header: React.ReactNode;
    rows: React.ReactNode;
    empty: React.ReactNode;
    actions: {
        add: (index?: number) => () => void;
        remove: (index?: number) => () => void;
    };
    removeData: (index: number) => void;
    addData: (index?: number) => void;
    renderHeader: (cb: () => React.ReactNode) => React.ReactNode;
    renderRow: (cb: ChildrenRenderPropRowCallable) => React.ReactNode;
    renderEmpty: (cb: () => React.ReactNode) => React.ReactNode;
    renderComponent(): React.ReactNode;
    render(): React.JSX.Element;
}
export default Fieldset;
