import React from "react";
import { GridCellProps as RmwcGridCellProps, GridProps as RmwcGridProps } from "@rmwc/grid";
import { CSSProperties } from "react";
export type CellProps = RmwcGridCellProps & {
    children?: React.ReactNode;
    className?: string;
    style?: {
        [key: string]: any;
    };
};
export type GridProps = RmwcGridProps & {
    className?: string;
    style?: CSSProperties;
};
/**
 * Cell must be direct children of Grid component.
 */
export declare const Cell: (props: CellProps) => React.JSX.Element;
export type GridInnerProps = {
    children: React.ReactElement<typeof Cell> | React.ReactElement<typeof Cell>[];
    /**
     * CSS class name
     */
    className?: string;
};
export declare const GridInner: {
    (props: GridInnerProps): React.JSX.Element;
    displayName: string;
};
/**
 * Use Grid component to display a list of choices, once the handler is triggered.
 */
export declare const Grid: (props: GridProps) => React.JSX.Element;
