"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault").default;
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.getClasses = void 0;
var _classnames = _interopRequireDefault(require("classnames"));
var _clone = _interopRequireDefault(require("lodash/clone"));
/**
 * This is a pass-through that modifies your object's props and creates the required className prop by merging
 * the provided appendClasses(string) and any class names defined inside your props.
 * To you the function just do: {...getClasses (props)}
 * and make sure you are not spreading the `props` element, as this will clone and spread your current `props` element already.
 */
/**
 * TODO @ts-refactor figure out propList type
 */
var getClasses = exports.getClasses = function getClasses(propList, appendClasses) {
  var classes = "";
  var props = (0, _clone.default)(propList);
  if (propList.hasOwnProperty("className")) {
    classes = (0, _classnames.default)(propList.className);
    delete props.className;
  }
  if (typeof appendClasses !== "undefined") {
    classes = (0, _classnames.default)(classes, appendClasses);
  }
  props.className = classes;
  return props;
};

//# sourceMappingURL=ClassNames.js.map