import React from "react";
import { ImageEditorTool, ToolbarTool } from "./toolbar/types";
interface RenderPropArgs {
    render: () => React.ReactNode;
    getCanvasDataUrl: () => string;
    activeTool: ImageEditorTool | null;
    applyActiveTool: () => Promise<void>;
    cancelActiveTool: () => Promise<void>;
}
interface ImageEditorPropsPropsOptions {
    autoEnable: boolean;
}
interface ImageEditorProps {
    src: string;
    tools: ToolbarTool[];
    options?: {
        flip: ImageEditorPropsPropsOptions;
        filter: ImageEditorPropsPropsOptions;
        crop: ImageEditorPropsPropsOptions;
        rotate: ImageEditorPropsPropsOptions;
    };
    onToolActivate?: () => void;
    onToolDeactivate?: () => void;
    children?: (props: RenderPropArgs) => React.ReactNode;
}
interface ImageEditorState {
    tool: ImageEditorTool | null;
    src: string;
}
declare class ImageEditor extends React.Component<ImageEditorProps, ImageEditorState> {
    static defaultProps: Partial<ImageEditorProps>;
    state: ImageEditorState;
    canvas: React.RefObject<HTMLCanvasElement>;
    image?: HTMLImageElement;
    componentDidMount(): void;
    private readonly updateCanvas;
    private readonly activateTool;
    private readonly deactivateTool;
    readonly getCanvasDataUrl: () => string;
    private readonly applyActiveTool;
    private readonly cancelActiveTool;
    private readonly getToolOptions;
    render(): React.ReactNode;
}
export { ImageEditor };
