"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault").default;
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;
var _react = _interopRequireDefault(require("react"));
var _crop = require("./icons/crop.svg");
var _Button = require("../../Button");
var _Tooltip = require("../../Tooltip");
var _cropperjs = _interopRequireDefault(require("cropperjs"));
require("cropperjs/dist/cropper.css");
var cropper = undefined;
var renderForm = function renderForm() {
  return /*#__PURE__*/_react.default.createElement("div", {
    style: {
      textAlign: "center"
    }
  }, "Click and drag to crop a portion of the image. Hold Shift to persist aspect ratio.");
};
var tool = {
  name: "crop",
  icon: function icon(_ref) {
    var activateTool = _ref.activateTool;
    return /*#__PURE__*/_react.default.createElement(_Tooltip.Tooltip, {
      placement: "bottom",
      content: "Crop"
    }, /*#__PURE__*/_react.default.createElement(_Button.IconButton, {
      icon: /*#__PURE__*/_react.default.createElement(_crop.ReactComponent, null),
      onClick: function onClick() {
        return activateTool("crop");
      },
      "data-testid": "crop-item"
    }));
  },
  renderForm: renderForm,
  onActivate: function onActivate(_ref2) {
    var canvas = _ref2.canvas,
      options = _ref2.options;
    cropper = new _cropperjs.default(canvas.current, options);
  },
  cancel: function cancel() {
    return cropper && cropper.destroy();
  },
  apply: function apply(_ref3) {
    var canvas = _ref3.canvas;
    return new Promise(function (resolve) {
      if (!cropper) {
        resolve();
        return;
      }
      var current = canvas.current;
      var src = cropper.getCroppedCanvas().toDataURL();
      if (current) {
        var image = new window.Image();
        var ctx = current.getContext("2d");
        image.onload = function () {
          ctx.drawImage(image, 0, 0);
          current.width = image.width;
          current.height = image.height;
          ctx.drawImage(image, 0, 0);
          resolve();
        };
        image.src = src;
      }
      cropper.destroy();
      cropper = undefined;
    });
  }
};
var _default = exports.default = tool;

//# sourceMappingURL=crop.js.map