"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault").default;
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;
var _react = _interopRequireDefault(require("react"));
var _flip = require("./icons/flip.svg");
var _cropperjs = _interopRequireDefault(require("cropperjs"));
require("cropperjs/dist/cropper.css");
var _Button = require("../../Button");
var _Tooltip = require("../../Tooltip");
var cropper;
var flipped = {
  x: 1,
  y: 1
};
var renderForm = function renderForm() {
  return /*#__PURE__*/_react.default.createElement("div", {
    style: {
      textAlign: "center"
    }
  }, /*#__PURE__*/_react.default.createElement(_Button.ButtonDefault, {
    onClick: function onClick() {
      if (!cropper) {
        return;
      }
      flipped.x = flipped.x === 1 ? -1 : 1;
      cropper.scaleX(flipped.x);
    }
  }, "FlipX"), /*#__PURE__*/_react.default.createElement(_Button.ButtonDefault, {
    onClick: function onClick() {
      if (!cropper) {
        return;
      }
      flipped.y = flipped.y === 1 ? -1 : 1;
      cropper.scaleY(flipped.y);
    }
  }, "FlipY"));
};
var tool = {
  name: "flip",
  icon: function icon(_ref) {
    var activateTool = _ref.activateTool;
    return /*#__PURE__*/_react.default.createElement(_Tooltip.Tooltip, {
      placement: "bottom",
      content: "Flip"
    }, /*#__PURE__*/_react.default.createElement(_Button.IconButton, {
      icon: /*#__PURE__*/_react.default.createElement(_flip.ReactComponent, null),
      onClick: function onClick() {
        return activateTool("flip");
      },
      "data-testid": "flip-item"
    }));
  },
  renderForm: renderForm,
  cancel: function cancel() {
    return cropper && cropper.destroy();
  },
  onActivate: function onActivate(_ref2) {
    var canvas = _ref2.canvas;
    cropper = new _cropperjs.default(canvas.current, {
      background: false,
      modal: false,
      guides: false,
      dragMode: "none",
      highlight: false,
      autoCrop: false
    });
  },
  apply: function apply(_ref3) {
    var canvas = _ref3.canvas;
    return new Promise(function (resolve) {
      if (!cropper) {
        resolve();
        return;
      }
      var current = canvas.current;
      var src = cropper.getCroppedCanvas().toDataURL();
      if (current) {
        var image = new window.Image();
        var ctx = current.getContext("2d");
        image.onload = function () {
          ctx.drawImage(image, 0, 0);
          current.width = image.width;
          current.height = image.height;
          ctx.drawImage(image, 0, 0);
          resolve();
        };
        image.src = src;
      }
      cropper.destroy();
    });
  }
};
var _default = exports.default = tool;

//# sourceMappingURL=flip.js.map