"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault").default;
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;
var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));
var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));
var _callSuper2 = _interopRequireDefault(require("@babel/runtime/helpers/callSuper"));
var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));
var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));
var _react = _interopRequireDefault(require("react"));
var _rotateRight = require("./icons/rotateRight.svg");
var _Slider = require("../../Slider");
var _Tooltip = require("../../Tooltip");
var _Button = require("../../Button");
var _cropperjs = _interopRequireDefault(require("cropperjs"));
require("cropperjs/dist/cropper.css");
var cropper;
var RenderForm = /*#__PURE__*/function (_React$Component) {
  function RenderForm() {
    var _this;
    (0, _classCallCheck2.default)(this, RenderForm);
    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }
    _this = (0, _callSuper2.default)(this, RenderForm, [].concat(args));
    (0, _defineProperty2.default)(_this, "state", {
      rangeInput: 0
    });
    return _this;
  }
  (0, _inherits2.default)(RenderForm, _React$Component);
  return (0, _createClass2.default)(RenderForm, [{
    key: "render",
    value: function render() {
      var _this2 = this;
      return /*#__PURE__*/_react.default.createElement("div", {
        style: {
          width: "500px",
          margin: "0 auto"
        }
      }, /*#__PURE__*/_react.default.createElement(_Slider.Slider, {
        label: "Range Input",
        value: this.state.rangeInput,
        min: 0,
        max: 360,
        step: 10,
        discrete: true,
        displayMarkers: true,
        onInput: function onInput(value) {
          _this2.setState({
            rangeInput: value
          }, async function () {
            if (cropper) {
              cropper.rotateTo(parseInt(value, 10));
            }
          });
        }
      }));
    }
  }]);
}(_react.default.Component);
var tool = {
  name: "rotate",
  icon: function icon(_ref) {
    var activateTool = _ref.activateTool;
    return /*#__PURE__*/_react.default.createElement(_Tooltip.Tooltip, {
      placement: "bottom",
      content: "Rotate"
    }, /*#__PURE__*/_react.default.createElement(_Button.IconButton, {
      icon: /*#__PURE__*/_react.default.createElement(_rotateRight.ReactComponent, null),
      onClick: function onClick() {
        return activateTool("rotate");
      },
      "data-testid": "rotate-item"
    }));
  },
  renderForm: function renderForm(props) {
    return /*#__PURE__*/_react.default.createElement(RenderForm, props);
  },
  onActivate: function onActivate(_ref2) {
    var canvas = _ref2.canvas;
    /**
     * We can safely cast canvas.current as HTMLCanvasElement
     */
    cropper = new _cropperjs.default(canvas.current, {
      background: false,
      modal: false,
      guides: false,
      dragMode: "none",
      highlight: false,
      autoCrop: false
    });
  },
  cancel: function cancel() {
    return cropper && cropper.destroy();
  },
  apply: function apply(_ref3) {
    var canvas = _ref3.canvas;
    return new Promise(function (resolve) {
      if (!cropper) {
        resolve();
        return;
      }
      var current = canvas.current;
      var src = cropper.getCroppedCanvas().toDataURL();
      if (current) {
        var image = new window.Image();
        var ctx = current.getContext("2d");
        image.onload = function () {
          ctx.drawImage(image, 0, 0);
          current.width = image.width;
          current.height = image.height;
          ctx.drawImage(image, 0, 0);
        };
        image.src = src;
        resolve();
      }
      cropper.destroy();
    });
  }
};
var _default = exports.default = tool;

//# sourceMappingURL=rotate.js.map