"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault").default;
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;
var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));
var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));
var _callSuper2 = _interopRequireDefault(require("@babel/runtime/helpers/callSuper"));
var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));
var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));
var _react = _interopRequireDefault(require("react"));
var _classnames = _interopRequireDefault(require("classnames"));
var _roundAdd_photo_alternate24px = require("./icons/round-add_photo_alternate-24px.svg");
var _roundClose24px = require("./icons/round-close-24px.svg");
var _roundEdit24px = require("./icons/round-edit-24px.svg");
var _Typography = require("../Typography");
var _Progress = require("../Progress");
var _styled = require("./styled");
var Image = /*#__PURE__*/function (_React$Component) {
  function Image() {
    (0, _classCallCheck2.default)(this, Image);
    return (0, _callSuper2.default)(this, Image, arguments);
  }
  (0, _inherits2.default)(Image, _React$Component);
  return (0, _createClass2.default)(Image, [{
    key: "renderBlank",
    value: function renderBlank() {
      var _this$props = this.props,
        uploadImage = _this$props.uploadImage,
        round = _this$props.round;
      var ImageWrapper = round ? _styled.AddImageWrapperRound : _styled.AddImageWrapper;
      return /*#__PURE__*/_react.default.createElement(ImageWrapper, {
        "data-role": "select-image",
        onClick: function onClick() {
          uploadImage();
        }
      }, /*#__PURE__*/_react.default.createElement(_styled.AddImageIconWrapper, null, /*#__PURE__*/_react.default.createElement(_roundAdd_photo_alternate24px.ReactComponent, null), /*#__PURE__*/_react.default.createElement(_Typography.Typography, {
        use: "caption"
      }, this.props.placeholder)));
    }
  }, {
    key: "renderImg",
    value: function renderImg() {
      var _this$props2 = this.props,
        removeImage = _this$props2.removeImage,
        editImage = _this$props2.editImage,
        uploadImage = _this$props2.uploadImage,
        value = _this$props2.value,
        renderImagePreview = _this$props2.renderImagePreview;
      var imagePreviewProps = {
        src: value ? value.src : null,
        style: this.props.style ? this.props.style : null,
        onClick: function onClick() {
          return uploadImage();
        }
      };
      if (!imagePreviewProps.style) {
        imagePreviewProps.style = {};
      }
      if (!imagePreviewProps.style.width && !imagePreviewProps.style.height) {
        imagePreviewProps.style.width = "100%";
        imagePreviewProps.style.height = "100%";
      }
      var imagePreview = null;
      if (typeof renderImagePreview === "function") {
        imagePreview = renderImagePreview(imagePreviewProps);
      } else {
        imagePreview = /*#__PURE__*/_react.default.createElement("img", imagePreviewProps);
      }
      return /*#__PURE__*/_react.default.createElement(_styled.ImagePreviewWrapper, {
        "data-testid": "image-preview"
      }, imagePreview, typeof removeImage === "function" && /*#__PURE__*/_react.default.createElement(_styled.RemoveImage, {
        onClick: function onClick() {
          return removeImage(null);
        },
        "data-testid": "remove-image"
      }, /*#__PURE__*/_react.default.createElement(_roundClose24px.ReactComponent, null)), typeof editImage === "function" && /*#__PURE__*/_react.default.createElement(_styled.EditImage, {
        onClick: function onClick() {
          return editImage(value);
        }
      }, /*#__PURE__*/_react.default.createElement(_roundEdit24px.ReactComponent, null)), /*#__PURE__*/_react.default.createElement(_styled.AddImageWrapper, {
        "data-role": "select-image",
        onClick: function onClick() {
          uploadImage();
        }
      }, /*#__PURE__*/_react.default.createElement(_styled.AddImageIconWrapper, null, /*#__PURE__*/_react.default.createElement(_roundAdd_photo_alternate24px.ReactComponent, null), /*#__PURE__*/_react.default.createElement(_Typography.Typography, {
        use: "caption"
      }, this.props.placeholder))));
    }
  }, {
    key: "render",
    value: function render() {
      var _this$props3 = this.props,
        value = _this$props3.value,
        disabled = _this$props3.disabled,
        containerStyle = _this$props3.containerStyle;
      return /*#__PURE__*/_react.default.createElement("div", {
        className: (0, _classnames.default)({
          disabled: disabled
        }),
        style: containerStyle
      }, this.props.loading && /*#__PURE__*/_react.default.createElement(_Progress.CircularProgress, null), value && value.src ? this.renderImg() : this.renderBlank());
    }
  }]);
}(_react.default.Component);
(0, _defineProperty2.default)(Image, "defaultProps", {
  placeholder: "Select an image",
  containerStyle: {
    height: "100%"
  }
});
var _default = exports.default = Image;

//# sourceMappingURL=Image.js.map