"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault").default;
var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard").default;
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.ImageEditorDialog = void 0;
var _slicedToArray2 = _interopRequireDefault(require("@babel/runtime/helpers/slicedToArray"));
var _objectWithoutProperties2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutProperties"));
var _react = _interopRequireWildcard(require("react"));
var _ImageEditor = require("../ImageEditor");
var _Tooltip = require("../Tooltip");
var _emotion = require("emotion");
var _Dialog = require("../Dialog");
var _Button = require("../Button");
var _excluded = ["src", "options", "onAccept", "open", "dialogZIndex"];
var imageEditorDialog = (0, _emotion.css)({
  width: "100vw",
  height: "100vh",
  ".mdc-dialog__surface": {
    maxWidth: "100% !important",
    maxHeight: "100% !important",
    ".webiny-ui-dialog__content": {
      maxWidth: "100% !important",
      maxHeight: "100% !important",
      width: "100vw",
      height: "100vh",
      paddingTop: "0 !important"
    }
  }
});
var ImageEditorDialog = exports.ImageEditorDialog = function ImageEditorDialog(props) {
  var src = props.src,
    options = props.options,
    onAccept = props.onAccept,
    open = props.open,
    dialogZIndex = props.dialogZIndex,
    dialogProps = (0, _objectWithoutProperties2.default)(props, _excluded);
  var imageEditor = /*#__PURE__*/_react.default.createRef();
  var _useState = (0, _react.useState)(false),
    _useState2 = (0, _slicedToArray2.default)(_useState, 2),
    isSaving = _useState2[0],
    setIsSaving = _useState2[1];
  var onSave = async function onSave() {
    try {
      setIsSaving(true);
      var url = imageEditor.current ? imageEditor.current.getCanvasDataUrl() : "";
      await onAccept(url);
    } catch (e) {
      console.log(e);
    } finally {
      setIsSaving(false);
    }
  };
  return /*#__PURE__*/_react.default.createElement(_Dialog.Dialog, Object.assign({
    className: imageEditorDialog,
    style: {
      zIndex: dialogZIndex
    },
    open: open
  }, dialogProps), open && /*#__PURE__*/_react.default.createElement(_ImageEditor.ImageEditor, {
    ref: imageEditor,
    src: src,
    options: options
  }, function (_ref) {
    var render = _ref.render,
      activeTool = _ref.activeTool;
    return /*#__PURE__*/_react.default.createElement(_react.default.Fragment, null, /*#__PURE__*/_react.default.createElement(_Dialog.DialogContent, null, render()), /*#__PURE__*/_react.default.createElement(_Dialog.DialogActions, null, /*#__PURE__*/_react.default.createElement(_Dialog.DialogCancel, null, "Cancel"), activeTool ? /*#__PURE__*/_react.default.createElement(_Tooltip.Tooltip, {
      content: "Please close currently active tool.",
      placement: "top"
    }, /*#__PURE__*/_react.default.createElement(_Button.ButtonPrimary, {
      disabled: true
    }, "Save")) : /*#__PURE__*/_react.default.createElement(_Button.ButtonPrimary, {
      "data-testid": "dialog-accept",
      onClick: onSave,
      disabled: isSaving
    }, isSaving ? "Saving..." : "Save")));
  }));
};

//# sourceMappingURL=ImageEditorDialog.js.map