import React from "react";
import { SelectedFile, FileError } from "react-butterfiles";
import { FormComponentProps } from "../types";
interface MultiImageUploadProps extends FormComponentProps {
    label?: string;
    disabled?: boolean;
    description?: string;
    className?: string;
    accept?: string[];
    maxSize: string;
    imageEditor?: {
        [key: string]: any;
    };
    errorMessages: {
        maxSizeExceeded: string;
        unsupportedFileType: string;
        default: string;
    };
    cropper?: {
        [key: string]: any;
    };
}
interface State {
    errors?: FileError[];
    selectedImages: Record<string, any>;
    loading: boolean;
    imageEditor: {
        image: SelectedFile | null;
        open: boolean;
        index?: number;
    };
}
declare class MultiImageUpload extends React.Component<MultiImageUploadProps, State> {
    static defaultProps: Partial<MultiImageUploadProps>;
    state: State;
    onChange: (value: any) => Promise<void>;
    handleSelectedImages: (images: Array<SelectedFile>, selectedIndex?: number) => Promise<void>;
    handleErrors: (errors: Array<FileError>) => void;
    removeImage: (image: SelectedFile) => void;
    render(): React.JSX.Element;
}
export { MultiImageUpload };
