"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault").default;
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.MultiImageUpload = void 0;
var _toConsumableArray2 = _interopRequireDefault(require("@babel/runtime/helpers/toConsumableArray"));
var _objectSpread2 = _interopRequireDefault(require("@babel/runtime/helpers/objectSpread2"));
var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));
var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));
var _callSuper2 = _interopRequireDefault(require("@babel/runtime/helpers/callSuper"));
var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));
var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));
var _react = _interopRequireDefault(require("react"));
var _reactButterfiles = _interopRequireDefault(require("react-butterfiles"));
var _emotion = require("emotion");
var _classnames = _interopRequireDefault(require("classnames"));
var _FormElementMessage = require("../FormElementMessage");
var _Image = _interopRequireDefault(require("./Image"));
var _ImageEditorDialog = require("./ImageEditorDialog");
var imagesStyle = (0, _emotion.css)({
  ".disabled": {
    opacity: 0.75,
    pointerEvents: "none"
  },
  "ul.images": {
    listStyle: "none",
    li: {
      verticalAlign: "top",
      margin: 2,
      display: "inline-block",
      width: 150,
      height: 150,
      "&:last-child": {
        border: "1px solid lightgray",
        cursor: "pointer",
        textAlign: "center"
      }
    }
  }
});

// Do not apply editping for following image types.
// const noImageEditorTypes = ["image/svg+xml", "image/gif"];
var MultiImageUpload = exports.MultiImageUpload = /*#__PURE__*/function (_React$Component) {
  function MultiImageUpload() {
    var _this;
    (0, _classCallCheck2.default)(this, MultiImageUpload);
    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }
    _this = (0, _callSuper2.default)(this, MultiImageUpload, [].concat(args));
    (0, _defineProperty2.default)(_this, "state", {
      errors: undefined,
      selectedImages: {},
      loading: false,
      imageEditor: {
        open: false,
        image: null,
        index: undefined
      }
    });
    (0, _defineProperty2.default)(_this, "onChange", async function (value) {
      var _this$props = _this.props,
        onChange = _this$props.onChange,
        validate = _this$props.validate;
      onChange && (await onChange(value));
      validate && (await validate());
    });
    (0, _defineProperty2.default)(_this, "handleSelectedImages", async function (images) {
      var selectedIndex = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : 0;
      _this.setState({
        errors: undefined,
        loading: true
      }, async function () {
        var selectedImages = {};
        for (var i = 0; i < images.length; i++) {
          var image = images[i];
          selectedImages[selectedIndex + i] = (0, _objectSpread2.default)({}, image);
        }
        _this.setState({
          selectedImages: selectedImages
        }, async function () {
          var newValue = Array.isArray(_this.props.value) ? (0, _toConsumableArray2.default)(_this.props.value) : [];
          var convertedImages = [];
          for (var _i = 0; _i < images.length; _i++) {
            var _image = images[_i];
            convertedImages.push({
              src: _image.src.base64,
              name: _image.name,
              size: _image.size,
              type: _image.type
            });
          }
          newValue.splice.apply(newValue, [selectedIndex, 0].concat(convertedImages));
          await _this.onChange(newValue);
          _this.setState({
            loading: false
          });
        });
      });
    });
    (0, _defineProperty2.default)(_this, "handleErrors", function (errors) {
      _this.setState({
        errors: errors
      });
    });
    (0, _defineProperty2.default)(_this, "removeImage", function (image) {
      var _this$props2 = _this.props,
        value = _this$props2.value,
        onChange = _this$props2.onChange;
      if (!onChange) {
        return;
      }
      var images = Array.isArray(value) ? (0, _toConsumableArray2.default)(value) : [];
      images.splice(images.indexOf(image), 1);
      onChange(images);
    });
    return _this;
  }
  (0, _inherits2.default)(MultiImageUpload, _React$Component);
  return (0, _createClass2.default)(MultiImageUpload, [{
    key: "render",
    value: function render() {
      var _this2 = this;
      var _this$props3 = this.props,
        value = _this$props3.value,
        validation = _this$props3.validation,
        label = _this$props3.label,
        description = _this$props3.description,
        disabled = _this$props3.disabled,
        imageEditor = _this$props3.imageEditor,
        accept = _this$props3.accept,
        maxSize = _this$props3.maxSize,
        className = _this$props3.className;
      /**
       * TODO: figure out the correct type
       */
      var imageEditorImageSrc = "";
      if (this.state.imageEditor.image) {
        // @ts-expect-error
        imageEditorImageSrc = this.state.imageEditor.image.src;
        console.warn("Figure out correct type if this.state.imageEditor.image.src");
        console.log(this.state.imageEditor.image.src);
      }
      var _ref = validation || {},
        validationIsValid = _ref.isValid,
        validationMessage = _ref.message;
      /**
       * accept can safely be cast because we have default value
       */
      return /*#__PURE__*/_react.default.createElement("div", {
        className: (0, _classnames.default)(imagesStyle, className)
      }, label && /*#__PURE__*/_react.default.createElement("div", {
        className: "mdc-floating-label mdc-floating-label--float-above"
      }, label), /*#__PURE__*/_react.default.createElement(_ImageEditorDialog.ImageEditorDialog, {
        options: imageEditor,
        open: this.state.imageEditor.open,
        src: imageEditorImageSrc,
        onClose: function onClose() {
          _this2.setState(function (state) {
            state.imageEditor.open = false;
            return state;
          });
        },
        onAccept: function onAccept(src) {
          // We wrapped everything into setTimeout - prevents dialog freeze when larger image is selected.
          setTimeout(function () {
            _this2.setState({
              loading: true
            }, async function () {
              var newValue = Array.isArray(_this2.props.value) ? (0, _toConsumableArray2.default)(_this2.props.value) : [];
              var imageEditorImageIndex = _this2.state.imageEditor.index;
              newValue[imageEditorImageIndex].src = src;
              await _this2.onChange(newValue);
              _this2.setState({
                loading: false,
                imageEditor: {
                  image: null,
                  open: false,
                  index: undefined
                }
              });
            });
          });
        }
      }), /*#__PURE__*/_react.default.createElement(_reactButterfiles.default, {
        accept: accept,
        maxSize: maxSize,
        multiple: true,
        convertToBase64: true,
        onSuccess: function onSuccess(files) {
          _this2.handleSelectedImages(files, Array.isArray(value) ? value.length : 0);
        },
        onError: function onError(errors) {
          return _this2.handleErrors(errors);
        }
      }, function (_ref2) {
        var browseFiles = _ref2.browseFiles,
          getDropZoneProps = _ref2.getDropZoneProps;
        var images = Array.isArray(value) ? (0, _toConsumableArray2.default)(value) : [];
        return /*#__PURE__*/_react.default.createElement("div", getDropZoneProps({
          className: (0, _classnames.default)({
            disabled: disabled
          })
        }), /*#__PURE__*/_react.default.createElement("ul", {
          className: "images"
        }, images.map(function (image, index) {
          return /*#__PURE__*/_react.default.createElement("li", {
            key: index
          }, /*#__PURE__*/_react.default.createElement(_Image.default, {
            loading: _this2.state.selectedImages[index] && _this2.state.loading,
            value: image.file || image,
            removeImage: function removeImage() {
              return _this2.removeImage(image.file || image);
            },
            editImage: _this2.state.selectedImages[index] && function () {
              _this2.setState({
                imageEditor: {
                  index: index,
                  open: true,
                  image: _this2.state.selectedImages[index]
                }
              });
            },
            uploadImage: function uploadImage() {
              browseFiles({
                onSuccess: function onSuccess(files) {
                  _this2.handleSelectedImages(files, index + 1);
                },
                onError: function onError(errors) {
                  return _this2.handleErrors(errors);
                }
              });
            }
          }));
        }), /*#__PURE__*/_react.default.createElement("li", null, /*#__PURE__*/_react.default.createElement(_Image.default, {
          disabled: _this2.state.loading,
          uploadImage: function uploadImage() {
            browseFiles({
              onSuccess: function onSuccess(files) {
                _this2.handleSelectedImages(files, Array.isArray(value) ? value.length : 0);
              },
              onError: function onError(errors) {
                return _this2.handleErrors(errors);
              }
            });
          }
        }))));
      }), validationIsValid === false && /*#__PURE__*/_react.default.createElement(_FormElementMessage.FormElementMessage, {
        error: true
      }, validationMessage), validationIsValid !== false && description && /*#__PURE__*/_react.default.createElement(_FormElementMessage.FormElementMessage, null, description), Array.isArray(this.state.errors) && /*#__PURE__*/_react.default.createElement(_FormElementMessage.FormElementMessage, {
        error: true
      }, "Your selection of images failed because of the following images:", /*#__PURE__*/_react.default.createElement("ul", null, this.state.errors.map(function (error, index) {
        /**
         * We need to cast as existing keys in errorMessages, otherwise TS throws an error
         */
        var errorType = error.type;
        var message = _this2.props.errorMessages[errorType];
        var errorFileName = error.file ? error.file.name : "";
        return /*#__PURE__*/_react.default.createElement("li", {
          key: errorFileName + index
        }, index + 1, ". ", /*#__PURE__*/_react.default.createElement("strong", null, errorFileName), " -\xA0", message || _this2.props.errorMessages.default);
      }))));
    }
  }]);
}(_react.default.Component);
(0, _defineProperty2.default)(MultiImageUpload, "defaultProps", {
  accept: ["image/jpeg", "image/png", "image/gif", "image/svg+xml"],
  maxSize: "5mb",
  imageEditor: {},
  errorMessages: {
    maxSizeExceeded: "Max size exceeded.",
    unsupportedFileType: "Unsupported file type.",
    default: "An error occurred."
  }
});

//# sourceMappingURL=MultiImageUpload.js.map