import React from "react";
import { FormComponentProps } from "../types";
import { SelectedFile, FileError } from "react-butterfiles";
interface SingleImageUploadProps extends FormComponentProps {
    label?: string;
    disabled?: boolean;
    description?: string;
    className?: string;
    accept?: string[];
    maxSize: string;
    imageEditor?: {
        [key: string]: any;
    };
    renderImagePreview?: () => React.ReactElement<any>;
    showRemoveImageButton?: boolean;
    errorMessages: {
        maxSizeExceeded: string;
        unsupportedFileType: string;
        default: string;
        multipleNotAllowed: string;
        multipleMaxSizeExceeded: string;
    };
}
interface StateImage {
    name: string;
    type: string;
    size: number;
    src?: string;
}
interface State {
    loading: boolean;
    error: FileError | null;
    imageEditor: {
        image: StateImage | null;
        open: boolean;
    };
}
export declare class SingleImageUpload extends React.Component<SingleImageUploadProps, State> {
    static defaultProps: Partial<SingleImageUploadProps>;
    state: State;
    handleFiles: (images: SelectedFile[]) => void;
    handleErrors: (errors: FileError[]) => void;
    render(): React.JSX.Element;
}
export {};
