import React from "react";
import { TextFieldProps } from "@rmwc/textfield";
import { FormComponentProps } from "../types";
import { ReactElement } from "react";
export type InputProps<TValue = any> = FormComponentProps<TValue> & TextFieldProps & {
    autoComplete?: string;
    rawOnChange?: boolean;
    autoFocus?: boolean;
    placeholder?: string;
    description?: string | ReactElement;
    rows?: number;
    maxLength?: number;
    onBlur?: (e: React.SyntheticEvent<HTMLInputElement>) => any;
    onKeyDown?: (e: React.SyntheticEvent<HTMLInputElement>) => any;
    onEnter?: () => any;
    className?: string;
    "data-testid"?: string;
    size?: "small" | "medium" | "large";
    children?: React.ReactNode;
};
export type InputOnKeyDownProps = React.SyntheticEvent<HTMLInputElement> & {
    key?: string;
};
export declare const Input: (props: InputProps) => React.JSX.Element;
