"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault").default;
var _objectSpread2 = _interopRequireDefault(require("@babel/runtime/helpers/objectSpread2"));
var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));
var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));
var _callSuper2 = _interopRequireDefault(require("@babel/runtime/helpers/callSuper"));
var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));
var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));
var _react = _interopRequireDefault(require("react"));
var _index = require("../index");
var _react2 = require("@testing-library/react");
afterEach(_react2.cleanup);
function setup() {
  var props = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};
  var renderArg = {
    // eslint-disable-next-line
    onChange: function onChange(_) {},
    value: null
  };

  // We cast "as unknown as React.ReactNode" here because renderProp has a "jest.Mock<null, [controllerArg: any]>" type,
  // but the "Input" component expect React.ReactNode to be the type of the "children" property.
  var renderProp = jest.fn(function (controllerArg) {
    Object.assign(renderArg, controllerArg);
    return null;
  });
  var onChange = props.onChange ? props.onChange : function () {
    return void 0;
  };
  var Test = /*#__PURE__*/function (_React$Component) {
    function Test() {
      var _this;
      (0, _classCallCheck2.default)(this, Test);
      for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
        args[_key] = arguments[_key];
      }
      _this = (0, _callSuper2.default)(this, Test, [].concat(args));
      (0, _defineProperty2.default)(_this, "state", {
        value: "init-value"
      });
      (0, _defineProperty2.default)(_this, "onChange", function (value) {
        _this.setState({
          value: value
        });
      });
      return _this;
    }
    (0, _inherits2.default)(Test, _React$Component);
    return (0, _createClass2.default)(Test, [{
      key: "render",
      value: function render() {
        return /*#__PURE__*/_react.default.createElement(_index.Input, Object.assign({}, props, {
          value: this.state.value,
          onChange: callAll(onChange, this.onChange)
        }), renderProp);
      }
    }]);
  }(_react.default.Component);
  var utils = (0, _react2.render)(/*#__PURE__*/_react.default.createElement(Test, null));
  return (0, _objectSpread2.default)({
    renderArg: renderArg
  }, utils);
}

/**
 * This return a function that will call all the given functions with
 * the arguments with which it's called. It does a null-check before
 * attempting to call the functions and can take any number of functions.
 * @param {...Function} fns the functions to call
 * @return {Function} the function that calls all the functions
 */
function callAll() {
  for (var _len2 = arguments.length, fns = new Array(_len2), _key2 = 0; _key2 < _len2; _key2++) {
    fns[_key2] = arguments[_key2];
  }
  return function () {
    for (var _len3 = arguments.length, args = new Array(_len3), _key3 = 0; _key3 < _len3; _key3++) {
      args[_key3] = arguments[_key3];
    }
    fns.forEach(function (fn) {
      fn && fn.apply(void 0, args);
    });
  };
}
describe("Input tests", function () {
  test("passes expected props to render prop", function () {
    var _setup = setup(),
      renderArg = _setup.renderArg;
    expect(renderArg).toContainKeys(["value", "validation", "onChange", "onBlur"]);
  });
  test("updates value via onChange", function () {
    var _setup2 = setup(),
      renderArg = _setup2.renderArg;
    expect(renderArg.value).toBe("init-value");
    renderArg.onChange("new-value");
    expect(renderArg.value).toBe("new-value");
    renderArg.onChange("third-value");
    expect(renderArg.value).toBe("third-value");
  });
});

//# sourceMappingURL=Input.test.js.map