import React from "react";
import { ListItem, ListProps } from "..";
import { PaginationProp, SortersProp } from "./types";
interface DataListProps {
    children?: ((props: any) => React.ReactNode) | null;
    title?: React.ReactNode;
    data?: Record<string, any>[] | null;
    refresh?: (() => void) | null;
    loading?: boolean;
    loader?: React.ReactNode;
    noData?: React.ReactNode;
    pagination?: PaginationProp;
    setSorters?: ((sorter: any) => void) | null;
    sorters?: SortersProp | null;
    actions?: React.ReactNode;
    filters?: React.ReactNode;
    multiSelectActions?: React.ReactNode;
    multiSelectAll?: (value: boolean, data: Record<string, any>[] | null) => void;
    isAllMultiSelected?: (data: Record<string, any>[] | null) => boolean;
    isNoneMultiSelected?: (data: Record<string, any>[] | null) => boolean;
    showOptions?: {
        refresh?: boolean;
        pagination?: boolean;
        filters?: boolean;
        sorters?: boolean;
        [key: string]: any;
    };
    search?: React.ReactElement;
    modalOverlay?: React.ReactElement;
    modalOverlayAction?: React.ReactElement;
    subHeader?: React.ReactElement;
    meta?: Record<string, any> | null;
    setPage?: ((page: string) => void) | null;
    setPerPage?: ((page: string) => void) | null;
    perPageOptions?: number[];
}
export declare const DataList: (propsInput: DataListProps) => React.JSX.Element;
export interface ScrollListProps extends ListProps {
    children: React.ReactElement<typeof ListItem>[];
}
export declare const ScrollList: (props: ScrollListProps) => React.JSX.Element;
export {};
