import React from "react";
import { ListItem, ListProps } from "..";
import { PaginationProp, SortersProp } from "./types";
interface DataListData {
    [key: string]: Record<string, any>[];
}
interface DataListWithSectionsProps {
    children?: ((props: any) => React.ReactNode) | null;
    title?: React.ReactNode;
    data?: DataListData | null;
    refresh?: (() => void) | null;
    loading?: boolean;
    loader?: React.ReactNode;
    noData?: React.ReactNode;
    pagination?: PaginationProp;
    setSorters?: ((sorter: any) => void) | null;
    sorters?: SortersProp | null;
    actions?: React.ReactNode;
    filters?: React.ReactNode;
    multiSelectActions?: React.ReactNode;
    multiSelectAll?: (value: boolean, data: DataListData | null) => void;
    isAllMultiSelected?: (data: DataListData | null) => boolean;
    isNoneMultiSelected?: (data: DataListData | null) => boolean;
    showOptions?: {
        refresh?: boolean;
        pagination?: boolean;
        filters?: boolean;
        sorters?: boolean;
        [key: string]: any;
    };
    search?: React.ReactElement;
    modalOverlay?: React.ReactElement;
    modalOverlayAction?: React.ReactElement;
    subHeader?: React.ReactElement;
    meta?: Record<string, any> | null;
    setPage?: ((page: string) => void) | null;
    setPerPage?: ((page: string) => void) | null;
    perPageOptions?: number[];
}
export declare const DataListWithSections: (propsInput: DataListWithSectionsProps) => React.JSX.Element;
interface ScrollListWithSectionsProps extends ListProps {
    children: React.ReactElement<typeof ListItem>[];
}
export declare const ScrollListWithSections: (props: ScrollListWithSectionsProps) => React.JSX.Element;
export {};
