import React from "react";
export type PaginationProp = {
    setPage?: (page: number) => void;
    setPreviousPage?: () => void;
    setNextPage?: () => void;
    hasNextPage?: boolean;
    hasPreviousPage?: boolean;
    setPerPage?: (amount: number) => void;
    perPageOptions?: number[];
};
export type SortersProp = Array<{
    label: string;
    value: any;
}>;
export type Props = {
    children?: <T = Record<string, any>>(props: T) => React.ReactNode;
    title?: React.ReactNode;
    data?: Record<string, any>[];
    refresh?: () => void;
    loading?: boolean;
    loader?: React.ReactNode;
    pagination?: PaginationProp;
    setPage?: (page: string) => void;
    setSorters?: (sorter: any) => void;
    setFilters?: (filters: any) => void;
    sorters?: SortersProp;
    multiActions?: any[];
};
