"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault").default;
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.SimpleListItem = exports.ListTopCaption = exports.ListTextOverline = exports.ListSelectBox = exports.ListItemTextSecondary = exports.ListItemTextPrimary = exports.ListItemText = exports.ListItemMeta = exports.ListItemGraphic = exports.ListItem = exports.ListBottomCaption = exports.ListActions = exports.List = void 0;
var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));
var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));
var _callSuper2 = _interopRequireDefault(require("@babel/runtime/helpers/callSuper"));
var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));
var _react = _interopRequireDefault(require("react"));
var _list = require("@rmwc/list");
var _Typography = require("../Typography");
var _classnames = _interopRequireDefault(require("classnames"));
var _styled = require("./styled");
/**
 * ListItem components are placed as direct children to List component.
 * @param props
 * @returns {*}
 * @constructor
 */
var ListItem = exports.ListItem = function ListItem(props) {
  return /*#__PURE__*/_react.default.createElement(_list.ListItem, props);
};
/**
 * Use List component to display data and offer additional actions if needed.
 */
var List = exports.List = /*#__PURE__*/function (_React$Component) {
  function List() {
    (0, _classCallCheck2.default)(this, List);
    return (0, _callSuper2.default)(this, List, arguments);
  }
  (0, _inherits2.default)(List, _React$Component);
  return (0, _createClass2.default)(List, [{
    key: "render",
    value: function render() {
      return /*#__PURE__*/_react.default.createElement(_list.List, Object.assign({}, this.props, {
        className: (0, _classnames.default)(_styled.webinyList, this.props.className)
      }), this.props.children);
    }
  }]);
}(_react.default.Component);
/**
 * Used to show regular text in list items.
 * @param props
 * @returns {*}
 * @constructor
 */
var ListItemText = exports.ListItemText = function ListItemText(props) {
  return /*#__PURE__*/_react.default.createElement(_list.ListItemText, props, props.children);
};
var ListItemTextPrimary = exports.ListItemTextPrimary = function ListItemTextPrimary(props) {
  return /*#__PURE__*/_react.default.createElement(_list.ListItemPrimaryText, null, props.children);
};
/**
 * Used to show secondary text in list items.
 * @param props
 * @returns {*}
 * @constructor
 */
var ListItemTextSecondary = exports.ListItemTextSecondary = function ListItemTextSecondary(props) {
  return /*#__PURE__*/_react.default.createElement(_list.ListItemSecondaryText, null, props.children);
};
/**
 * Can be used to show an icon or any other custom element. Rendered on the left side.
 * @param props
 * @returns {*}
 * @constructor
 */
var ListItemGraphic = exports.ListItemGraphic = function ListItemGraphic(props) {
  return /*#__PURE__*/_react.default.createElement("div", Object.assign({}, props, {
    className: (0, _classnames.default)("mdc-deprecated-list-item__graphic", props.className)
  }), props.children);
};
/**
 * Can be used to show an icon or any other custom element. Rendered on the right side.
 * @param props
 * @returns {*}
 * @constructor
 */
var ListItemMeta = exports.ListItemMeta = function ListItemMeta(props) {
  return /*#__PURE__*/_react.default.createElement("span", Object.assign({}, props, {
    className: (0, _classnames.default)("mdc-deprecated-list-item__meta", props.className)
  }), props.children);
};
/**
 * Can be used to show a top caption inside ListItemMeta component.
 * @param props
 * @returns {*}
 * @constructor
 */
var ListTopCaption = exports.ListTopCaption = function ListTopCaption(props) {
  return /*#__PURE__*/_react.default.createElement("span", Object.assign({}, props, {
    className: "webiny-list-top-caption"
  }), /*#__PURE__*/_react.default.createElement(_Typography.Typography, {
    use: "overline"
  }, props.children));
};
/**
 * Can be used to show a bottom caption inside ListItemMeta component.
 * @param props
 * @returns {*}
 * @constructor
 */
var ListBottomCaption = exports.ListBottomCaption = function ListBottomCaption(props) {
  return /*#__PURE__*/_react.default.createElement("span", Object.assign({}, props, {
    className: "webiny-list-bottom-caption"
  }), /*#__PURE__*/_react.default.createElement(_Typography.Typography, {
    use: "overline"
  }, props.children));
};
/**
 * Can be used to show an overline text inside ListItem component.
 * @param props
 * @returns {*}
 * @constructor
 */
var ListTextOverline = exports.ListTextOverline = function ListTextOverline(props) {
  return /*#__PURE__*/_react.default.createElement("span", Object.assign({}, props, {
    className: "webiny-list-text-overline"
  }), /*#__PURE__*/_react.default.createElement(_Typography.Typography, {
    use: "overline"
  }, props.children));
};
/**
 * Used to contain the actions inside ListItemMate component.
 * @param props
 * @returns {*}
 * @constructor
 */
var ListActions = exports.ListActions = function ListActions(props) {
  return /*#__PURE__*/_react.default.createElement("span", Object.assign({}, props, {
    className: "webiny-list-actions"
  }), props.children);
};
/**
 * Used to hold the Checkbox element for multi-select options.
 * @param {*} props
 */
var ListSelectBox = exports.ListSelectBox = function ListSelectBox(props) {
  return /*#__PURE__*/_react.default.createElement(ListItemGraphic, null, /*#__PURE__*/_react.default.createElement(_styled.SelectBoxWrapper, null, props.children));
};
var SimpleListItem = exports.SimpleListItem = function SimpleListItem(props) {
  return /*#__PURE__*/_react.default.createElement(_list.SimpleListItem, props);
};

//# sourceMappingURL=List.js.map