import React from "react";
import { MenuProps as RmwcMenuProps, MenuItemProps as BaseMenuItemProps } from "@rmwc/menu";
export type MenuChildrenFunctionProps = {
    closeMenu: () => void;
};
export interface RenderableMenuChildren {
    (props: MenuChildrenFunctionProps): React.ReactNode;
}
export type MenuProps = Omit<RmwcMenuProps, "children"> & {
    handle?: React.ReactElement;
    anchor?: "bottomEnd" | "bottomLeft" | "bottomRight" | "bottomStart" | "topEnd" | "topLeft" | "topRight" | "topStart";
    className?: string;
    disabled?: boolean;
    onOpen?: () => void;
    onClose?: () => void;
    "data-testid"?: string;
    portalZIndex?: number;
} & ({
    children: React.ReactNode | RenderableMenuChildren;
    render?: never;
} | {
    render: RenderableMenuChildren;
    children?: never;
});
/**
 * Use Menu component to display a list of choices, once the handler is triggered.
 */
declare const Menu: (props: MenuProps) => React.JSX.Element;
declare const MenuDivider: () => React.JSX.Element;
interface MenuItemProps extends BaseMenuItemProps {
    children: React.ReactNode;
    className?: string;
    onClick?: (event: React.MouseEvent) => void;
    "data-testid"?: string;
}
declare const MenuItem: ({ disabled, className, ...rest }: MenuItemProps) => React.JSX.Element;
export { Menu, MenuItem, MenuDivider };
