import React from "react";
import { OutputBlockData, OutputData, SanitizerConfig, ToolSettings } from "@editorjs/editorjs";
import { FormComponentProps } from "@webiny/form";
export interface OnReadyParams {
    editor: any;
    initialData: OutputData;
}
export type RichTextEditorValue = OutputBlockData[];
export interface RichTextEditorProps {
    autofocus?: boolean;
    className?: string;
    context?: {
        [key: string]: any;
    };
    description?: string;
    disabled?: boolean;
    label?: string;
    logLevel?: string;
    minHeight?: number;
    onChange?: (data: RichTextEditorValue) => void;
    onReady?: (params: OnReadyParams) => void;
    placeholder?: string;
    readOnly?: boolean;
    sanitizer?: SanitizerConfig;
    tools?: {
        [toolName: string]: ToolSettings;
    };
    validation?: FormComponentProps["validation"];
    value?: RichTextEditorValue;
}
export declare const RichTextEditor: (props: RichTextEditorProps) => React.JSX.Element;
