"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault").default;
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.createPropsFromConfig = void 0;
var _objectSpread2 = _interopRequireDefault(require("@babel/runtime/helpers/objectSpread2"));
/**
 * Creates RichTextEditor props from the given config (or array of configs).
 *
 * TODO: figure out types for editor and return type of the function.
 */
var createPropsFromConfig = exports.createPropsFromConfig = function createPropsFromConfig(config) {
  var configs = Array.isArray(config) ? config : [config];
  return {
    onReady: function onReady(params) {
      configs.forEach(function (config) {
        if (typeof config.onReady === "function") {
          config.onReady(params);
        }
      });
    },
    tools: configs.reduce(function (tools, config) {
      return (0, _objectSpread2.default)((0, _objectSpread2.default)({}, tools), config.tools);
    }, {})
  };
};

//# sourceMappingURL=createPropsFromConfig.js.map