import React from "react";
import { SelectProps as RmwcSelectProps } from "@rmwc/select";
import { FormComponentProps } from "../types";
export type SelectProps = FormComponentProps & RmwcSelectProps & {
    label?: string;
    disabled?: boolean;
    description?: string;
    placeholder?: string;
    box?: string;
    children?: (React.ReactElement<"option"> | React.ReactElement<"optgroup">)[];
    rootProps?: {
        [key: string]: any;
    };
    className?: string;
    size?: "small" | "medium" | "large";
};
/**
 * We check for null and undefined in the value because React is complaining about those values.
 * Error says to use the empty string in null/undefined case.
 */
export declare const Select: (props: SelectProps) => React.JSX.Element;
export default Select;
