import React from "react";
import { TabProps } from "./Tab";
export interface TabsProps extends React.HTMLAttributes<HTMLDivElement> {
    /**
     * Append a class name.
     */
    className?: string;
    /**
     * Callback to execute when a tab is changed.
     */
    onActivate?: (index: number) => void;
    /**
     * Active tab index value.
     */
    value?: number;
    /**
     * Tab ID for the testing.
     */
    "data-testid"?: string;
}
interface TabItem extends TabProps {
    id: string;
}
interface TabsContext {
    addTab(props: TabItem): void;
    removeTab(id: string): void;
}
export declare const TabsContext: React.Context<TabsContext | undefined>;
/**
 * Use Tabs component to display a list of choices, once the handler is triggered.
 */
export declare const Tabs: {
    ({ children, value, onActivate, className, ...props }: TabsProps): React.JSX.Element;
    displayName: string;
};
export {};
