import React from "react";
import { FormComponentProps } from "../types";
interface TagsProps extends FormComponentProps {
    /**
     * Component label.
     */
    label?: string;
    /**
     * Are input and chosen tags disabled?
     */
    disabled?: boolean;
    /**
     * Placeholder text for the form control. Set to a blank string to create a non-floating placeholder label.
     */
    placeholder?: string;
    /**
     * Description beneath the input.
     */
    description?: string;
    /**
     * A className for the root element.
     */
    className?: string;
    /**
     * A list of tags.
     */
    value?: string[];
    /**
     * Callback that gets executed on change of input value.
     */
    onInput?: <T = unknown>(value: T) => void;
    /**
     * Callback that gets executed when the input is focused.
     */
    onFocus?: (ev: Event) => void;
    /**
     * Automatically focus on the tags input.
     */
    autoFocus?: boolean;
    /**
     * Protected tags cannot be removed by the user.
     */
    protectedTags?: string[];
}
export declare const Tags: (props: TagsProps) => React.JSX.Element;
export default Tags;
