import React from "react";
import "rc-tooltip/assets/bootstrap_white.css";
import "./style.scss";
type TooltipPropsContent = (() => React.ReactChild) | React.ReactChild | React.ReactFragment | React.ReactPortal;
export interface TooltipProps {
    children: React.ReactNode;
    content: TooltipPropsContent;
    trigger?: string;
    placement?: "left" | "right" | "top" | "bottom" | "topLeft" | "topRight" | "bottomLeft" | "bottomRight";
    className?: string;
}
interface State {
    tooltipIsOpen: boolean;
}
/**
 * Use Tooltip component to display a list of choices, once the handler is triggered.
 */
declare class Tooltip extends React.Component<TooltipProps, State> {
    state: {
        tooltipIsOpen: boolean;
    };
    onVisibleChange: (visible?: boolean) => void;
    render(): React.JSX.Element;
}
export { Tooltip };
